// Kevin Pang
// Neural Networks
// Fall 2003
//
// som.h
// Header file for the Som class

#pragma once

#include <vector>
#include "neuron.h"
using namespace std;

class Som
{
public:
	Som(int size, int numInputs);
	~Som();

	void train(double r, double g, double b);		// Train the SOM with input values of r, g, b
	void display();									// Draw the current SOM
	void reset();

	int getEpoch();
private:
	vector<vector<Neuron> > map;
	int size_;										// Width/Height of the map
	int numInputs_;									// Number of inputs
	int iteration_;									// What iteration number we're on
	int epoch_;										// How many epochs we've went through
};